Index: palm/trunk/SOURCE/nesting_offl_mod.f90
===================================================================
--- palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4225)
+++ palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4226)
@@ -281,5 +881,5 @@
 #if defined( __parallel )
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( volume_flow_l, volume_flow, 3, MPI_REAL, MPI_SUM,      &
+       CALL MPI_ALLREDUCE( volume_flow_l, volume_flow, 3, MPI_REAL, MPI_SUM,   &
                            comm2d, ierr )
 #else
@@ -314,12 +914,8 @@
     SUBROUTINE nesting_offl_bc                     
 
-       IMPLICIT NONE
-
        INTEGER(iwp) ::  i !< running index x-direction
        INTEGER(iwp) ::  j !< running index y-direction
        INTEGER(iwp) ::  k !< running index z-direction
        INTEGER(iwp) ::  n !< running index for chemical species
-
-       REAL(wp) ::  fac_dt   !< interpolation factor
        
        REAL(wp), DIMENSION(nzb:nzt+1) ::  pt_ref   !< reference profile for potential temperature
@@ -347,12 +943,4 @@
        u_ref_l  = 0.0_wp
        v_ref_l  = 0.0_wp
-!
-!--    Determine interpolation factor and limit it to 1. This is because
-!--    t+dt can slightly exceed time(tind_p) before boundary data is updated 
-!--    again. 
-       fac_dt = ( time_since_reference_point - nest_offl%time(nest_offl%tind)  &
-                + dt_3d ) /                                                    &
-           ( nest_offl%time(nest_offl%tind_p) - nest_offl%time(nest_offl%tind) )
-       fac_dt = MIN( 1.0_wp, fac_dt )
 !
 !--    Set boundary conditions of u-, v-, w-component, as well as q, and pt.
@@ -863,5 +1451,22 @@
        CALL nesting_offl_calc_zi
        CALL adjust_sponge_layer 
-    
+       
+       CALL  cpu_log( log_point(58), 'offline nesting', 'stop' )
+
+       IF ( debug_output_timestep )  CALL debug_message( 'nesting_offl_bc', 'end' )
+
+
+    END SUBROUTINE nesting_offl_bc
+
+!------------------------------------------------------------------------------!
+! Description:
+!------------------------------------------------------------------------------!
+!>  Update of the geostrophic wind components.
+!>  @todo: update geostrophic wind also in the child domains (should be done
+!>         in the nesting.
+!------------------------------------------------------------------------------!
+    SUBROUTINE nesting_offl_geostrophic_wind
+
+       INTEGER(iwp) ::  k
 !
 !--    Update geostrophic wind components from dynamic input file. 
@@ -874,11 +1479,27 @@
        ug(nzt+1) = ug(nzt)
        vg(nzt+1) = vg(nzt)
-    
-       CALL  cpu_log( log_point(58), 'offline nesting', 'stop' )
-
-       IF ( debug_output_timestep )  CALL debug_message( 'nesting_offl_bc', 'end' )
-
-
-    END SUBROUTINE nesting_offl_bc
+
+    END SUBROUTINE nesting_offl_geostrophic_wind
+
+!------------------------------------------------------------------------------!
+! Description:
+!------------------------------------------------------------------------------!
+!>  Determine the interpolation constant for time interpolation. The 
+!>  calculation is separated from the nesting_offl_bc and 
+!>  nesting_offl_geostrophic_wind in order to be independent on the order 
+!>  of calls. 
+!------------------------------------------------------------------------------!
+    SUBROUTINE nesting_offl_interpolation_factor
+!
+!--    Determine interpolation factor and limit it to 1. This is because
+!--    t+dt can slightly exceed time(tind_p) before boundary data is updated 
+!--    again. 
+       fac_dt = ( time_utc_init + time_since_reference_point                   &
+                - nest_offl%time(nest_offl%tind) + dt_3d ) /                   &
+           ( nest_offl%time(nest_offl%tind_p) - nest_offl%time(nest_offl%tind) )
+
+       fac_dt = MIN( 1.0_wp, fac_dt )
+
+    END SUBROUTINE nesting_offl_interpolation_factor
 
 !------------------------------------------------------------------------------!
@@ -889,11 +1510,4 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE nesting_offl_calc_zi
-       
-       USE basic_constants_and_equations_mod,                                  &
-           ONLY:  g
-       
-       USE kinds
-
-       IMPLICIT NONE 
 
        INTEGER(iwp) :: i                            !< loop index in x-direction
@@ -1070,14 +1684,4 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE adjust_sponge_layer
-       
-       USE arrays_3d,                                                          &
-           ONLY:  rdf, rdf_sc, zu
-       
-       USE basic_constants_and_equations_mod,                                  &
-           ONLY:  pi
-       
-       USE kinds
-
-       IMPLICIT NONE 
 
        INTEGER(iwp) :: k   !< loop index in z-direction
@@ -1116,6 +1720,4 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE nesting_offl_check_parameters 
-
-       IMPLICIT NONE
 !
 !--    Check if offline nesting is applied in nested child domain.
@@ -1123,5 +1725,5 @@
           message_string = 'Offline nesting is only applicable in root model.'
           CALL message( 'offline_nesting_check_parameters', 'PA0622', 1, 2, 0, 6, 0 )       
-       ENDIF     
+       ENDIF
 
     END SUBROUTINE nesting_offl_check_parameters
@@ -1133,6 +1735,4 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE nesting_offl_parin 
-
-       IMPLICIT NONE
        
        CHARACTER (LEN=80) ::  line   !< dummy string that contains the current line of the parameter file
@@ -1174,6 +1774,4 @@
     SUBROUTINE nesting_offl_header ( io )
 
-       IMPLICIT NONE
-
        INTEGER(iwp), INTENT(IN) ::  io !< Unit of the output file
 
@@ -1199,10 +1797,5 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE nesting_offl_init
-    
-       USE netcdf_data_input_mod,                                              &
-           ONLY:  netcdf_data_input_offline_nesting  
-
-       IMPLICIT NONE
-       
+           
        INTEGER(iwp) ::  n !< running index for chemical species
 
@@ -1340,6 +1933,15 @@
        ENDIF
 !
+!--    Before initial data input is initiated, check if dynamic input file is 
+!--    present.
+       IF ( .NOT. input_pids_dynamic )  THEN
+          message_string = 'nesting_offline = .TRUE. requires dynamic '  //    &
+                            'input file ' //                                   &
+                            TRIM( input_file_dynamic ) // TRIM( coupling_char )
+          CALL message( 'nesting_offl_init', 'PA0546', 1, 2, 0, 6, 0 )
+       ENDIF
+!
 !--    Read COSMO data at lateral and top boundaries
-       CALL netcdf_data_input_offline_nesting
+       CALL nesting_offl_input
 !
 !--    Check if sufficient time steps are provided to cover the entire 
@@ -1347,8 +1949,15 @@
 !--    not for the soil/wall spinup. However, as the spinup time is added
 !--    to the end_time, this must be considered here. 
-       IF ( end_time - spinup_time > nest_offl%time(nest_offl%nt-1) )  THEN
-          message_string = 'end_time > provided time in offline nesting.'
-          CALL message( 'offline_nesting_check_parameters', 'PA0183',          &
-                        1, 2, 0, 6, 0 ) 
+       IF ( end_time - spinup_time >                                           &
+            nest_offl%time(nest_offl%nt-1) - time_utc_init )  THEN
+          message_string = 'end_time of the simulation exceeds the ' //        &
+                           'time dimension in the dynamic input file.'
+          CALL message( 'nesting_offl_init', 'PA0183', 1, 2, 0, 6, 0 ) 
+       ENDIF
+
+       IF ( nest_offl%time(0) /= time_utc_init )  THEN
+          message_string = 'Offline nesting: time dimension must start at ' // &
+                           ' time_utc_init.'
+          CALL message( 'nesting_offl_init', 'PA0676', 1, 2, 0, 6, 0 )
        ENDIF
 !
@@ -1466,8 +2075,4 @@
 !------------------------------------------------------------------------------!
     FUNCTION interpolate_in_time( var_t1, var_t2, fac  ) 
-       
-       USE kinds
-
-       IMPLICIT NONE 
 
        REAL(wp)            :: interpolate_in_time !< time-interpolated boundary value
